---
variables:
  GITLAB_CI_DOCKER_IMAGE_DOCKER: 'docker:20.10.18'
  GITLAB_CI_DOCKER_IMAGE_BINFMT: 'tonistiigi/binfmt:qemu-v7.0.0-28'
  GITLAB_CI_DOCKER_BUILDX_PLATFORMS: 'linux/amd64'
  GITLAB_CI_DOCKER_BUILDX_CACHE_TO: '1'
  GITLAB_CI_DOCKER_IMAGE_TAG_LATEST: '1'
  GITLAB_CI_DOCKER_IMAGE_TAG_LATEST_NAME: 'latest'
  GITLAB_CI_DOCKER_IMAGE_TAG_CACHE_NAME: 'cache'
  GITLAB_CI_DOCKER_IMAGE_PUSH: '1'

docker:
  image: ${GITLAB_CI_DOCKER_IMAGE_DOCKER}
  before_script:
    - docker run --privileged --rm ${GITLAB_CI_DOCKER_IMAGE_BINFMT} --uninstall qemu-*
    - docker run --privileged --rm ${GITLAB_CI_DOCKER_IMAGE_BINFMT} --install all
  services:
    - ${GITLAB_CI_DOCKER_IMAGE_DOCKER}-dind
  script:
    - |
      cat << EOF > /etc/buildkitd.toml
      [worker.oci]
      max-parallelism = 1
      EOF
    - >-
      docker buildx
      create
      --config /etc/buildkitd.toml
      --use
      --name container
      --driver docker-container
      --bootstrap
    - 'CACHE_IMAGE="${CI_REGISTRY_IMAGE:+$CI_REGISTRY_IMAGE/${GITLAB_CI_DOCKER_IMAGE_NAME}:${GITLAB_CI_DOCKER_IMAGE_TAG_CACHE_NAME}}"; export CACHE_IMAGE'
    - '[ -z "$CI_MERGE_REQUEST_IID" ] || unset CI_REGISTRY_IMAGE GITLAB_CI_DOCKER_BUILDX_CACHE_TO'
    - '[ -z "$CI_REGISTRY_IMAGE" ] || (echo "$CI_REGISTRY_PASSWORD" | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY)'
    - '[ -z "$DOCKERHUB_PASSWORD" ] || (echo "$DOCKERHUB_PASSWORD" | docker login -u $DOCKERHUB_USER --password-stdin)'
    - >-
      docker buildx
      bake
      --progress plain
      -f docker-compose.yml
      $([ "$CI_PIPELINE_SOURCE" != "web" ] || echo " --no-cache")
      ${CACHE_IMAGE:+ -f docker-compose.cache.yml}
      ${GITLAB_CI_DOCKER_PULL:+ --pull}
      --set "*.platform=${GITLAB_CI_DOCKER_BUILDX_PLATFORMS}"
      ${GITLAB_CI_DOCKER_BUILDX_CACHE_TO:+${CACHE_IMAGE:+ --set "*.cache-to=type=registry,ref=$CACHE_IMAGE"}}
      ${GITLAB_CI_DOCKER_IMAGE_VERSION:+${CI_REGISTRY_IMAGE:+ --set "*.tags=$CI_REGISTRY_IMAGE/${GITLAB_CI_DOCKER_IMAGE_NAME}:${GITLAB_CI_DOCKER_IMAGE_VERSION}"}}
      ${GITLAB_CI_DOCKER_IMAGE_TAG_LATEST:+${CI_REGISTRY_IMAGE:+ --set "*.tags=$CI_REGISTRY_IMAGE/${GITLAB_CI_DOCKER_IMAGE_NAME}:${GITLAB_CI_DOCKER_IMAGE_TAG_LATEST_NAME}"}}
      ${GITLAB_CI_DOCKER_IMAGE_PUSH:+${CI_REGISTRY_IMAGE:+ --push}}
      ${GITLAB_CI_DOCKER_IMAGE_VERSION:+${DOCKERHUB_PASSWORD:+ --set "*.tags=librespace/${GITLAB_CI_DOCKER_IMAGE_NAME}:${GITLAB_CI_DOCKER_IMAGE_VERSION}"}}
      ${GITLAB_CI_DOCKER_IMAGE_TAG_LATEST:+${DOCKERHUB_PASSWORD:+ --set "*.tags=librespace/${GITLAB_CI_DOCKER_IMAGE_NAME}:${GITLAB_CI_DOCKER_IMAGE_TAG_LATEST_NAME}"}}
      ${GITLAB_CI_DOCKER_IMAGE_PUSH:+${DOCKERHUB_PASSWORD:+ --push}}
      ${GITLAB_CI_DOCKER_IMAGE_BUILD_TARGET}
